% EEGLAB history file generated on the 27-Mar-2021
% ------------------------------------------------
% Author: Wei-Chun Yang
% Dataset "inria-bci-challenge" is available on (https://www.kaggle.com/c/inria-bci-challenge)
subject=['02','06','07','11','12','13','14','16','17','18','20','21','22','23','24','26'];
for num = 1:2:32
	%  connect 5 session together
	filename = ['Data_S',subject(num:num+1)];
	csvfile= ['inria-bci-challenge/train/','Data_S',subject(num:num+1),'_Sess01.csv'];
	data1 = csvread(csvfile, 1, 1);
	data1(:,57)=[];
	data1=transpose(data1);
	
	csvfile= ['inria-bci-challenge/train/','Data_S',subject(num:num+1),'_Sess02.csv'];
	data2 = csvread(csvfile, 1, 1);
	data2(:,57)=[];
	data2=transpose(data2);
	
	csvfile= ['inria-bci-challenge/train/','Data_S',subject(num:num+1),'_Sess03.csv'];
	data3 = csvread(csvfile, 1, 1);
	data3(:,57)=[];
	data3=transpose(data3);
	
	csvfile= ['inria-bci-challenge/train/','Data_S',subject(num:num+1),'_Sess04.csv'];
	data4 = csvread(csvfile, 1, 1);
	data4(:,57)=[];
	data4=transpose(data4);
	
	csvfile= ['inria-bci-challenge/train/','Data_S',subject(num:num+1),'_Sess05.csv'];
	data5 = csvread(csvfile, 1, 1);
	data5(:,57)=[];
	data5=transpose(data5);
	
	alldata=cat(2,data1,data2,data3,data4,data5);
	
	EEG.etc.eeglabvers = '2020.0'; % this tracks which version of EEGLAB is being used, you may ignore it
	EEG = pop_importdata('dataformat','array','nbchan',56,'data','alldata','setname',filename,'srate',200,'pnts',0,'xmin',0); % load data into eeglab
	EEG = eeg_checkset( EEG );
	EEG = pop_chanevent(EEG, 57,'edge','leading','edgelen',0);%remove eog channel
	EEG = eeg_checkset( EEG );
	EEG = pop_chanedit(EEG, 'lookup','eeglab2020_0/plugins/dipfit/standard_BESA/standard-10-5-cap385.elp', 
		'append', 1, 'append', 2, 'append', 3, 'append', 4, 'append', 5, 'append', 6, 'append', 7, 'append', 8, 'append', 9, 'append', 10, 'append', 11, 'append', 12, 'append', 13, 'append', 14, 'append', 15, 'append', 16, 'append', 17, 'append', 18, 'append', 19, 'append', 20, 'append', 21, 'append', 22, 'append', 23, 'append', 24, 'append', 25, 'append', 26, 'append', 27, 'append', 28, 'append', 29, 'append', 30, 'append', 31, 'append', 32, 'append', 33, 'append', 34, 'append', 35, 'append', 36, 'append', 37, 'append', 38, 'append', 39, 'append', 40, 'append', 41, 'append', 42, 'append', 43, 'append', 44, 'append', 45, 'append', 46, 'append', 47, 'append', 48, 'append', 49, 'append', 50, 'append', 51, 'append', 52, 'append', 53, 'append', 54, 'append', 55, 
		'changefield', {56,'datachan',1}, 'changefield', {55,'datachan',1}, 'changefield', {54,'datachan',1}, 'changefield', {53,'datachan',1}, 'changefield', {52,'datachan',1}, 'changefield', {51,'datachan',1}, 'changefield', {50,'datachan',1}, 'changefield', {49,'datachan',1}, 'changefield', {48,'datachan',1}, 'changefield', {47,'datachan',1}, 'changefield', {46,'datachan',1}, 'changefield', {45,'datachan',1}, 'changefield', {44,'datachan',1}, 'changefield', {44,'datachan',0}, 'changefield', {44,'datachan',1}, 'changefield', {43,'datachan',1}, 'changefield', {42,'datachan',1}, 'changefield', {41,'datachan',1}, 'changefield', {40,'datachan',1}, 'changefield', {39,'datachan',1}, 'changefield', {38,'datachan',1}, 'changefield', {37,'datachan',1}, 'changefield', {36,'datachan',1}, 'changefield', {35,'datachan',1}, 'changefield', {34,'datachan',1}, 'changefield', {33,'datachan',1}, 'changefield', {32,'datachan',1}, 'changefield', {31,'datachan',1}, 'changefield', {30,'datachan',1}, 'changefield', {29,'datachan',1}, 'changefield', {28,'datachan',1}, 'changefield', {27,'datachan',1}, 'changefield', {26,'datachan',1}, 'changefield', {25,'datachan',1}, 'changefield', {24,'datachan',1}, 'changefield', {23,'datachan',1}, 'changefield', {22,'datachan',1}, 'changefield', {21,'datachan',1}, 'changefield', {20,'datachan',1}, 'changefield', {19,'datachan',1}, 'changefield', {18,'datachan',1}, 'changefield', {17,'datachan',1}, 'changefield',{16,'datachan',1}, 'changefield', {15,'datachan',1},'changefield',{14,'datachan',1},'changefield',{13,'datachan',1},'changefield',{12,'datachan',1},'changefield',{11,'datachan',1},'changefield',{10,'datachan',1},'changefield',{9,'datachan',1},'changefield',{8,'datachan',1},'changefield',{7,'datachan',1},'changefield',{6,'datachan',1},'changefield',{5,'datachan',1},'changefield',{4,'datachan',1},'changefield',{3,'datachan',1},'changefield',{2,'datachan',1},'changefield',{1,'labels','Fp1'},'changefield',{2,'labels','Fp2'},'changefield',{3,'labels','AF7'},'changefield',{4,'labels','AF3'},'changefield',{5,'labels','AF4'},'changefield',{6,'labels','AF8'},'changefield',{7,'labels','F7'},'changefield',{8,'labels','F5'},'changefield',{9,'labels','F3'},'changefield',{10,'labels','F2'},'changefield',{10,'labels','F1'},'changefield',{11,'labels','Fz'},'changefield',{12,'labels','F2'},'changefield',{13,'labels','F4'},'changefield',{14,'labels','F6'},'changefield',{15,'labels','F8'},'changefield',{16,'labels','FT7'},'changefield',{17,'labels','FC5'},'changefield',{18,'labels','FC3'},'changefield',{19,'labels','FC1'},'changefield',{20,'labels','FCz'},'changefield',{21,'labels','FC2'},'changefield',{22,'labels','FC4'},'changefield',{23,'labels','FC6'},'changefield',{24,'labels','FT8'},'changefield',{25,'labels','T7'},'changefield',{26,'labels','C5'},'changefield',{27,'labels','C3'},'changefield',{28,'labels','C1'},'changefield',{29,'labels','Cz'},'changefield',{30,'labels','C2'},'changefield',{31,'labels','C4'},'changefield',{32,'labels','C6'},'changefield',{33,'labels','T8'},'changefield',{34,'labels','TP7'},'changefield',{35,'labels','CP5'},'changefield',{36,'labels','CP3'},'changefield',{37,'labels','CP1'},'changefield',{38,'labels','CPz'},'changefield',{39,'labels','CP2'},'changefield',{40,'labels','CP4'},'changefield',{41,'labels','CP6'},'changefield',{42,'labels','TP8'},'changefield',{43,'labels','P7'},'changefield',{44,'labels','P5'},'changefield',{45,'labels','P3'},'changefield',{46,'labels','P1'},'changefield',{47,'labels','Pz'},'changefield',{48,'labels','P2'},'changefield',{49,'labels','P4'},'changefield',{50,'labels','P6'},'changefield',{51,'labels','P8'},'changefield',{52,'labels','PO7'},'changefield',{53,'labels','POz'},'changefield',{54,'labels','P08'},'changefield',{55,'labels','O1'},'changefield',{56,'labels','O2'},'changefield',{56,'theta','162'},'changefield',{55,'theta','198'},'changefield',{54,'theta','144'},'changefield',{53,'theta','180'},'changefield',{52,'theta','216'},'changefield',{51,'theta','126'},'changefield',{50,'theta','129'},'changefield',{49,'theta','139.4'},'changefield',{48,'theta','159.8'},'changefield',{47,'theta','180'},'changefield',{46,'theta','200.2'},'changefield',{45,'theta','220.6'},'changefield',{44,'theta','231'},'changefield',{43,'theta','234'},'changefield',{42,'theta','108'},'changefield',{41,'theta','109.3'},'changefield',{40,'theta','116.5'},'changefield',{39,'theta','140.3'},'changefield',{38,'theta','180'},'changefield',{37,'theta','219.7'},'changefield',{36,'theta','243.5'},'changefield',{35,'theta','250.7'},'changefield',{34,'theta','252'},'changefield',{33,'theta','90'},'changefield',{32,'theta','90'},'changefield',{31,'theta','90'},'changefield',{30,'theta','90'},'changefield',{29,'theta','90'},'changefield',{28,'theta','-90'},'changefield',{27,'theta','-90'},'changefield',{26,'theta','-90'},'changefield',{25,'theta','-90'},'changefield',{24,'theta','72'},'changefield',{23,'theta','70.7'},'changefield',{22,'theta','63.5'},'changefield',{21,'theta','39.7'},'changefield',{20,'theta','0'},'changefield',{19,'theta','-39.7'},'changefield',{18,'theta','-63.5'},'changefield',{17,'theta','-70.7'},'changefield',{16,'theta','-72'},'changefield',{15,'theta','54'},'changefield',{14,'theta','51'},'changefield',{13,'theta','40.6'},'changefield',{12,'theta','20.2'},'changefield',{11,'theta','0'},'changefield',{10,'theta','-20.2'},'changefield',{9,'theta','-40.6'},'changefield',{8,'theta','-51'},'changefield',{7,'theta','-54'},'changefield',{6,'theta','36'},'changefield',{5,'theta','22.1'},'changefield',{4,'theta','-22.1'},'changefield',{3,'theta','-36'},'changefield',{2,'theta','18'},'changefield',{1,'theta','-18'},'changefield',{1,'radius','0.36'},'changefield',{2,'radius','0.36'},'changefield',{3,'radius','0.36'},'changefield',{4,'radius','0.2932'},'changefield',{5,'radius','0.2932'},'changefield',{6,'radius','0.36'},'changefield',{7,'radius','0.36'},'changefield',{8,'radius','0.3032'},'changefield',{9,'radius','0.2336'},'changefield',{10,'radius','0.1872'},'changefield',{11,'radius','0.18'},'changefield',{12,'radius','0.1872'},'changefield',{13,'radius','0.18'},'changefield',{13,'radius','0.2336'},'changefield',{14,'radius','0.3032'},'changefield',{15,'radius','0.36'},'changefield',{16,'radius','0.36'},'changefield',{17,'radius','0.2904'},'changefield',{18,'radius','0.194'},'changefield',{19,'radius','0.112'},'changefield',{20,'radius','0.09'},'changefield',{21,'radius','0.112'},'changefield',{22,'radius','0.194'},'changefield',{23,'radius','0.2904'},'changefield',{24,'radius','0.36'},'changefield',{25,'radius','0.36'},'changefield',{26,'radius','0.2864'},'changefield',{27,'radius','0.18'},'changefield',{28,'radius','0.0736'},'changefield',{29,'radius','0'},'changefield',{30,'radius','0.0736'},'changefield',{31,'radius','0.18'},'changefield',{32,'radius','0.2864'},'changefield',{33,'radius','0.36'},'changefield',{34,'radius','0.36'},'changefield',{35,'radius','0.2904'},'changefield',{36,'radius','0.194'},'changefield',{37,'radius','0.112'},'changefield',{38,'radius','0.09'},'changefield',{39,'radius','0.112'},'changefield',{40,'radius','0.194'},'changefield',{41,'radius','0.2904'},'changefield',{42,'radius','0.36'},'changefield',{43,'radius','0.36'},'changefield',{44,'radius','0.3032'},'changefield',{45,'radius','0.2336'},'changefield',{46,'radius','0.1872'},'changefield',{47,'radius','0.18'},'changefield',{48,'radius','0.1872'},'changefield',{49,'radius','0.18'},'changefield',{49,'radius','0.2336'},'changefield',{50,'radius','0.3032'},'changefield',{51,'radius','0.36'},'changefield',{52,'radius','0.36'},'changefield',{53,'radius','0.27'},'changefield',{54,'radius','0.36'},'changefield',{55,'radius','0.36'},'changefield',{56,'radius','0.36'},'convert',{'topo2all'}
	); % channel location
	EEG = eeg_checkset( EEG );
	EEG = pop_resample( EEG, 128); % downsampling to 128Hz
	EEG = eeg_checkset( EEG );
	EEG = pop_reref( EEG, []); % re-reference by CAR
	EEG = eeg_checkset( EEG );
	EEG = pop_eegfiltnew(EEG, 'locutoff',1,'hicutoff',40,'plotfreqz',1); % Band pass filter to 1-40 Hz
	EEG = eeg_checkset( EEG );
	saveset=[filename,'.set'];
	EEG = pop_saveset( EEG, 'filename',saveset,'filepath','bci-challenge/original/'); % save data
	EEG = eeg_checkset( EEG );
	EEG = pop_runica(EEG, 'extended',1,'interupt','on'); % run ica
	EEG = eeg_checkset( EEG );
	EEG = pop_iclabel(EEG, 'default'); % run iclabel
	EEG = eeg_checkset( EEG );
	saveset=[filename,'.set'];
	EEG = pop_saveset( EEG, 'filename',saveset,'filepath','bci-challenge/ICA/'); % save data
	EEG = eeg_checkset( EEG );

end